# CornStarch
# by Eresse <eresse@eresse.net>

# InfiniScroll JS

# InfiniScroll Window-Controlled Containers
infiniscroll_window_ctrl_containers = []

# Detach Handler
window.infiniscroll_detach_handler = (container) ->

	# Check Window-Controlled
	if container.attr('infiniscroll-ctrl') == 'window'

		# Remove from Window-Controlled Containers
		idx = infiniscroll_window_ctrl_containers.indexOf container
		infiniscroll_window_ctrl_containers.splice idx, 1
	else

		# Unbind Scroll Event
		container.unbind 'scroll'

# Attach Handler
window.infiniscroll_attach_handler = (container) ->

	# Check Window-Controlled
	if container.attr('infiniscroll-ctrl') == 'window'

		# Add to Window-Controlled Containers
		infiniscroll_window_ctrl_containers.push container

	else

		# Bind Scroll Event
		container.scroll infiniscroll_element_handler

# Should Element Reload
window.infiniscroll_should_reload = (container) ->

	# Check Window-Controlled
	if container.attr('infiniscroll-ctrl') == 'window'

		# Check Window / Document Scroll
		e = $(window)
		(e.scrollTop() + e.height()) >= ($(document).height() - container.attr('infiniscroll-margin'))
	else

		# Check Element Scroll
		e = container[0]
		(e.clientHeight > 0) && ((e.scrollTop + e.clientHeight) >= (e.scrollHeight - container.attr('infiniscroll-margin')))

# InfiniScroll
window.infiniscroll = (container) ->

	# Acquire Container
	c = $("##{container}")

	# Acquire Path & Next
	path = c.attr 'infiniscroll-trgt'
	args = c.attr 'infiniscroll-args'
	onload = c.attr 'infiniscroll-onload'
	next = c.attr 'infiniscroll-next'

	# Check End
	return if next == 'none'

	# Construct Args
	args = if args == '' then '?' else args + '&'
	args = args + 'current_page=' + next

	# Build URL
	full_path = path + args

	# Fetch Data
	$.getJSON full_path, (data) ->

		# Update Next
		c.attr 'infiniscroll-next', data['next']

		# Append Content
		c.append data['content']

		# Run onload Callback
		window[onload]() if onload && onload != ''

		# Detach Handler
		infiniscroll_detach_handler c

		# Check Scroll
		if infiniscroll_should_reload c

			# Scroll
			infiniscroll container
		else

			# Re-Attach Handler
			infiniscroll_attach_handler c

# Reset Container
window.infiniscroll_reset = (container) ->

# Acquire Container
	c = $("##{container}")

	# Reset Next
	c.attr 'infiniscroll-next', '0'

	# Empty Container
	c.empty()

	# Jumpstart Container
	infiniscroll container

# Window Scroll Handler
window.infiniscroll_window_handler = ->

	# Check Window-Controlled Containers
	return unless infiniscroll_window_ctrl_containers.length

	# Run through Window-Controlled Containers
	infiniscroll_window_ctrl_containers[0].each ->

		# Acquire Container
		e = $(@)

		# Handle Scrolling
		infiniscroll_handler e

# Element Scroll Handler
window.infiniscroll_element_handler = ->

	# Acquire Element
	c = $(@)

	# Handle Scroll
	infiniscroll_handler c

# Scroll Handler
window.infiniscroll_handler = (c) ->

	# Check Position
	if infiniscroll_should_reload c

		# Detach Handler
		infiniscroll_detach_handler c

		# Scroll it, bitch !
		infiniscroll c[0].id

# InfiniScroll Init
window.infiniscroll_init = ->

	# Acquire Containers
	infiniscroll_containers = $('.infiniscroll-container')

	# Init Containers
	infiniscroll_containers.each ->

		# Acquire
		c = $(@)

		# Detach Shit
		infiniscroll_detach_handler c

		# Check Scroll
		if infiniscroll_should_reload c

			# Scroll it, bitch !
			infiniscroll c[0].id

		# Attach Handler
		infiniscroll_attach_handler c

		# Hook Window Scroll Events
		$(document).scroll infiniscroll_window_handler

# Initialize InfiniScroll for the Page
$(document).on 'turbolinks:load', infiniscroll_init
