# CornStarch
# by Eresse <eresse@eresse.net>

# CornStarch Module
module CornStarch

	# Sessions Controller
	class SessionsController < ::ApplicationController

		# Filters
		skip_before_filter :auth_filter, only: [:new, :create]
		before_filter :unauth_filter, only: [:new, :create]

		# Index
		def index
			redirect_to root_url
		end

		# New (Login)
		def new
		end

		# Create (Login)
		def create
			@user = user_model.find_by uid_field => params[uid_field]
			if @user && @user.authenticate(params[:password]) && (@user.respond_to?(:cs_authenticate) ? @user.try(:cs_authenticate, params) : true)
				session[:user_id] = @user.id
				session[:loaded_user_locale] = false
				I18n.locale = @user.locale
				redirect_to (params[:back] == 'true' ? :back : root_url), notice: notice_msg(nil, nil, :login, :pass)
			else
				flash.now[:alert] = notice_msg(nil, nil, :login, :fail)
				render action: :new
			end
		end

		# Drop (Logout)
		def drop
			session[:user_id] = nil
			redirect_to root_url, notice: notice_msg(nil, nil, :logout, nil)
		end
	end
end
