# CornStarch
# by Eresse <eresse@eresse.net>

# CornStarch Module
module CornStarch

	# CornStarch Helper
	module CornStarchHelper

		# Extend
		extend ActionView::Helpers
		extend ActionView::Context

		# Icon Link
		def icon_link_to target, icon, text = nil, extra = nil
			link_to target, extra do
				image_tag(icon) + (text ? ' ' + text : '')
			end
		end

		# Render Link
		def render_link_to target, partial, text = nil, extra = nil
			link_to target, extra do
				(partial ? render(partial) : '') + (text ? ' ' + text : '').html_safe
			end
		end

		# Class Masher
		def class_mash base, classes
			class_s = base
			if classes.respond_to? :each
				classes.each { |c| class_s += " #{base}-#{c}" }
			else
				class_s += " #{base}-#{classes}"
			end
			class_s
		end

		# Missing Method Handler
		def method_missing name, *args, &block

			# Handle Generic Tag
			if name.to_s =~ /(.*)_tag/
				content_tag $1.to_sym, *args, &block

			# Default
			else
				super
			end
		end
	end
end
