# CornStarch
# by Eresse <eresse@eresse.net>

# CornStarch Module
module CornStarch

	# InfiniScroll Helper
	module InfiniscrollHelper

		# InfiniScroll Container
		def infiniscroll_container id, target, template = nil, onload = nil, control = :window, container_classes = [], extra_args = nil, n = 1

			# Prep Args
			first = true
			args = ''

			# Include Search Params
			if @infiniscroll[:params][:search]
				args = args + (first ? '?' : '&') + "search=#{@infiniscroll[:params][:search]}"
				first = false
			end

			# Include Pagination - Records Per Page
			if @infiniscroll[:params][:records_per_page]
				args = args + (first ? '?' : '&') + "records_per_page=#{@infiniscroll[:params][:records_per_page]}"
				first = false
			end

			args = args + (first ? '?' : '&') + extra_args.to_query if extra_args

			# Produce Container
			div_tag id: id, class: %w(infiniscroll-container) + container_classes, 'infiniscroll-trgt' => target, 'infiniscroll-onload' => onload, 'infiniscroll-args' => args, 'infiniscroll-next' => n, 'infiniscroll-ctrl' => control, 'infiniscroll-margin' => CORNSTARCH_CONF[:infiniscroll][:margin] do
				if template
					render partial: template.to_s, locals: extra_args
				else
					yield extra_args if block_given?
				end
			end
		end
	end
end
