# CornStarch
# by Eresse <eresse@eresse.net>

# CornStarch Configuration Initializer

# Includes
require 'rubygems'
require 'yaml'
require 'json'

# Load up Configuration
CORNSTARCH_CONF_FILE = "#{Rails.root}/config/corn_starch.yml"
CORNSTARCH_CONF = YAML::load_file CORNSTARCH_CONF_FILE if File.exist? CORNSTARCH_CONF_FILE
CORNSTARCH_CONF ||= {}
CORNSTARCH_CONF.deep_symbolize_keys!

######################
# Configure Defaults #
######################

# Pagination
CORNSTARCH_CONF[:pagination] ||= {}
CORNSTARCH_CONF[:pagination][:page_range] ||= 6
CORNSTARCH_CONF[:pagination][:records_per_page] ||= {}
CORNSTARCH_CONF[:pagination][:records_per_page][:default] ||= 10
CORNSTARCH_CONF[:pagination][:records_per_page][:opts] ||= [ 10, 25, 50, 100 ]

# InfiniScroll
CORNSTARCH_CONF[:infiniscroll] ||= {}
CORNSTARCH_CONF[:infiniscroll][:margin] = 300

# Authentication
CORNSTARCH_CONF[:authentication] ||= {}
CORNSTARCH_CONF[:authentication][:user_model] ||= {}
CORNSTARCH_CONF[:authentication][:user_model][:name] ||= 'User'
CORNSTARCH_CONF[:authentication][:user_model][:uid_field] ||= 'username'
